# PDF to Image #

The PDF To Image module provides automatic conversion of
uploaded PDF files to images.
It can be used either to create a snapshot of the front page,
or to generate a gallery of images from each page in the document.

The module provides a new widget for managing PDF file uploads.
It places generated images into a nominated Image field on the same content
type.

## Requirements ##

- File field with module field widget
- Image field as target for the module field widget.
- Core File module
- PHP version >= 7.4
- [Convert a pdf to an image](https://github.com/spatie/pdf-to-image) - a package that will convert PDF to image files
- Recommended Drupal version >= 9.5

## Installation ##

Install as you would normally install a contributed Drupal module. For further
information, see
[Installing Drupal Modules](https://www.drupal.org/docs/extending-drupal/installing-drupal-modules).

## Configuration ##

### Manual configuration ###

- First, add an image field on your chosen content type. This is where the
  generated images will be stored.
- Set the allowed fields to 1 if you just want a cover page, direct number to
  store only some count of pages or 'unlimited' if you want all pages
  to be generated.
- Next add a filefield to your chosen content type and choose
  'PDF to Image' as the widget.
  This filefield should be configured to only accept PDF file types.
- When configuring this field, you will be required to link the uploaded file
  field with the target image field.
- You can add image style handling to the image field rendering as normal to
  adjust the size of the results and how they display on the page.

## Usage ##

With the above configs set up right, you can now

* Create a piece of content
* if you upload a pdf and leave the image field blank, images will be generated
  for it.
* If you upload a PDF *and* an image of your choosing, that will be left alone.
* If you delete the image(s), an image of the PDF will be regenerated.
* If you upload non PDF file then:
  * If 'Process only PDF files' option is enabled, non PDF files will be ignored
  * If 'Process only PDF files' option is disabled,
    non PDF files will copied to the target field without changes
    * In this case make sure that the field extensions are compatible in both
      fields

## Troubleshooting ##

If nothing special seems to happen when saving a node, check the status report
and ensure the Imagemagick "convert" binary, and Ghostscript "gs" is available.

If it seems to start a batch job but fails, check the logs for more detail on
the command that was run and see what failed.

## Processing ##

Processing of PDF may take some time.

Larger documents use the 'batch' process to generate each page.
